SystemOrganization addCategory: #'Aeropuerto-Logic'!
SystemOrganization addCategory: #'Aeropuerto-AsientoDeAvion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Persona-Test'!
SystemOrganization addCategory: #'Aeropuerto-SistemaDeReservas-Test'!
SystemOrganization addCategory: #'Aeropuerto-Vuelo-Test'!
SystemOrganization addCategory: #'Aeropuerto-Pasajes-Test'!
SystemOrganization addCategory: #'Aeropuerto-Jet-Test'!
SystemOrganization addCategory: #'Aeropuerto-Comercial-Test'!

TestCase subclass: #ComercialTest
	instanceVariableNames: 'comercial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Comercial-Test'!

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:29'!
setUp 
	comercial := Comercial newNombre: 'Avion-Comercial'
	! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testCantidadDeAsientos
	self assert: ( comercial cantidadDeAsientos = 200)! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre 
	self assert: (comercial nombre = 'Avion-Comercial')! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testVelocidadPromedio 
	self assert: ( comercial velocidadPromedio = 800 )! !

TestCase subclass: #JetTest
	instanceVariableNames: 'jet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Jet-Test'!

!JetTest methodsFor: 'running' stamp: 'LeandroGomez 6/10/2012 14:24'!
setUp 
	jet := Jet newNombre: 'Avion-Jet'.! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testCantidadDeAsientos
	self assert: (jet cantidadDeAsientos = 60)! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre
	self assert: (jet nombre = 'Avion-Jet')! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testVelocidadPromedio
	self assert: (jet velocidadPromedio = 1200)! !

TestCase subclass: #PasajeTest
	instanceVariableNames: 'business economica primera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Pasajes-Test'!

!PasajeTest methodsFor: 'running' stamp: 'LeandroGomez 6/11/2012 12:21'!
setUp 
	| jet persona vuelo despegue|
	despegue := Date today addMonths: 4.
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	jet := Jet newNombre: 'Avion-Jet'.
	vuelo := Internacional newOrigen: 'Buenos Aires' destino: 'So Paulo' avion: jet fechaDeSalida: despegue.
	primera := Primera newPersona: persona vuelo: vuelo nroAsiento: 37.
	business := Business newPersona: persona vuelo: vuelo nroAsiento: 27.
	economica := Economica newPersona: persona vuelo: vuelo nroAsiento: 17.! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 11:49'!
testBusinessCostoPorClase
	self assert: (business costoPorClase = 0.75)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 11:48'!
testEconomicaCostoPorClase
	self assert: (economica costoPorClase = 0.5)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 12:04'!
testPrimeraCosto
	self assert: (primera costo = 2000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 12:12'!
testPrimeraCostoALaFecha
	| fecha |
	fecha := Date today addMonths: 2.
	self assert: ((primera costoALaFecha: fecha) = 571)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 12:09'!
testPrimeraCostoPorClase
	self assert: (primera costoPorClase = 1)! !

TestCase subclass: #PersonaTest
	instanceVariableNames: 'persona'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Persona-Test'!

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 12:21'!
setUp 
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:41'!
testApellido
	self assert: (persona fnacimiento = '5 may 1992' asDate)! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:41'!
testFechaNacimiento
	self assert: (persona apellido = 'Gomez')! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
testNacionalidad
	self assert: ( persona nacionalidad = 'Argentino' )! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:40'!
testNombre
	self assert: (persona nombre = 'Leandro')! !

TestCase subclass: #TestAsientoDeAvion
	instanceVariableNames: 'libre reservado confirmado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-AsientoDeAvion-Test'!

!TestAsientoDeAvion methodsFor: 'running' stamp: 'LeandroGomez 6/11/2012 20:05'!
setUp 
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
							fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
							
	reservado := AsientoDeAvion newNumero: 73.
	reservado asignar: persona.
	confirmado := AsientoDeAvion newNumero: 37.
	confirmado asignar: persona; confirmar.
	libre := AsientoDeAvion newNumero: 28.! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoEstado
	self assert: (confirmado estaConfirmado).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoLiberar
	confirmado liberar.
	self assert: ( confirmado estaLibre)! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:15'!
testAsientoConfirmadoNumero
	self assert: ( confirmado numero = 37 ).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoConfirmadoPersona
	self assert: ( confirmado persona nombre = 'Leandro' ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/11/2012 20:06'!
testAsientoLibreAsignarPersona
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
						fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	libre asignar: persona.
	self assert: ( libre esPasajero: persona).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoLibreEstado
	self assert: (libre estaLibre).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:06'!
testAsientoLibreNumero
	self assert: ( libre numero = 28 ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoLibrePersona
	self assert: ( libre persona  = nil ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoLibreReservar
	libre reservar.
	self assert: ( libre estaReservado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoConfirmar
	reservado confirmar.
	self assert: ( reservado estaConfirmado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoEstado
	self assert: (reservado estaReservado).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoLiberar
	reservado liberar.
	self assert: ( reservado estaLibre  )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:05'!
testAsientoReservadoNumero
	self assert: ( reservado numero= 73 ).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoReservadoPersona
	self assert: ( reservado persona nombre = 'Leandro' ).! !

TestCase subclass: #VueloTest
	instanceVariableNames: 'internacional transbordo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Vuelo-Test'!

!VueloTest methodsFor: 'running' stamp: 'LeandroGomez 6/11/2012 12:17'!
setUp 
	| avion avion2|
	avion := Jet newNombre: 'Avion-Jet'.

	internacional := Internacional newOrigen: 'So Paulo' destino: 'Fortaleza' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 3).
						
	transbordo := Transbordo newOrigen: 'Buenos Aires' destino: 'So Paulo' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 4) siguienteVuelo: internacional.
	
						! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:42'!
testTransbordoDestino
	self assert: (transbordo destino = 'So Paulo')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:52'!
testTransbordoDestinoFinal
	self assert: (transbordo destinoFinal = 'Fortaleza')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:52'!
testTransbordoDistanciaPromedio
	self assert: (transbordo distanciaPromedio = 4000)! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:56'!
testTransbordoDuracion
	self assert: ( transbordo duracion = 5)! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:42'!
testTransbordoOrigen
	self assert: (transbordo origen = 'Buenos Aires')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:41'!
testTransbordoSiguienteVueloDestino
	self assert: (transbordo siguienteVuelo destino = 'Fortaleza')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:43'!
testTransbordoSiguienteVueloOrigen
	self assert: (transbordo siguienteVuelo origen = 'So Paulo')! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:06'!
testinternacionalAsignarPersonaAAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: (internacional esPasajero: persona asiento: 37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:28'!
testinternacionalCancelar
	internacional cancelar.
	self assert: (internacional estaCancelado)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:45'!
testinternacionalCantidadDeAsentos
	self assert: (internacional cantidadDeAsientos = 60)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalConfirmarAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	internacional confirmar: 37.
	self assert: (internacional estaConfirmado:  37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/10/2012 23:58'!
testinternacionalDestinoFinal
	self assert: (internacional destinoFinal = 'Fortaleza')! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:31'!
testinternacionalDistanciaPromedio
	self assert: (internacional distanciaPromedio = 2000) ! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:47'!
testinternacionalDuracion
	self assert: ( internacional duracion = (5/3) )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:28'!
testinternacionalEsperaDespegue
	self assert: (internacional esperaDespegue)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 12:16'!
testinternacionalFechaSalida
	self assert: (internacional fechaSalida = ((Date today) addMonths: 3) )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalLiberarAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: (internacional estaReservado: 37).
	internacional liberar: 37.
	self assert: (internacional estaLibre: 37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/10/2012 23:59'!
testinternacionalOrigen
	self assert: (internacional origen = 'So Paulo' )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalPasajeroDelAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: ((internacional pasajeroDelAsiento: 37) == persona )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalReprogramarDespegue
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 3) ).
	internacional reprogramar: ((Date today) addMonths: 4) .
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 4) ).! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:08'!
testinternacionalReprogramarDespegueYAvion
	| avion | 
	avion := Jet newNombre: 'Avion-Jet'.
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 3) ).
	internacional reprogramar: ((Date today) addMonths: 5)  avion: avion.
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 5)  asDate ).
	self assert: ( internacional avion == avion ).! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:08'!
testinternacionalViajaPersona
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: ( internacional viaja: persona )! !

Object subclass: #AsientoDeAvion
	instanceVariableNames: 'estado persona numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:40'!
new
	self error: 'Un asiento de avion necesita un numero, use "newNumero: " '! !

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/11/2012 23:01'!
newNumero: unNumero
	|asiento|
	asiento := super new.
	asiento numero: unNumero.
	^asiento.! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:10'!
< unAsiento
	^(self numero < unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:09'!
<= unAsiento
	^(self numero <= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
= unAsiento
	^(self numero = unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
> unAsiento
	^(self numero > unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:23'!
>= unAsiento
	^(self numero >= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:02'!
asignar: unaPersona
	" Se asigna una Persona a un asiento "
	((self estaReservado) | (self estaConfirmado))
		ifTrue: [ self error: 'El asiento ya esta Reservado/Confirmado' ]
		ifFalse: [ 
				self reservar.
				self persona: unaPersona.
			 ]
! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 10:59'!
confirmar
	self estado: 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:03'!
esPasajero: unaPersona
	^self persona == unaPersona.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaConfirmado
	^self estado = 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaLibre
	^self estado = 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaReservado
	^self estado = 'Reservado'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado
	^ estado! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado: anObject
	estado := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:25'!
initialize 
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:02'!
liberar
	self persona: nil.
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero
	^ numero! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero: anObject
	numero := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona
	^ persona! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona: anObject
	persona := anObject! !

!AsientoDeAvion methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:56'!
printOn: aStream
	(self estado = 'Libre')
		ifTrue: [ aStream nextPutAll: 'Asiento numero ', self numero asString , ' libre.']
		ifFalse: [
			
			aStream nextPutAll: 'Asiento numero ', self numero asString ,
								' de ' , self persona nombre, ' ' ,self estado
				].
	! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:00'!
reservar
	self estado: 'Reservado'.! !

Object subclass: #Avion
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:41'!
new
	self error: 'Un avion necesita un nombre , use "newNombre: " '! !

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/9/2012 11:10'!
newNombre: unNombre 
	|avion|
	avion := super new.
	avion nombre: unNombre.
	^avion! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:36'!
cantidadDeAsientos 
	self subclassResponsibility.! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre
	^ nombre! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre: anObject
	nombre := anObject! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	self subclassResponsibility.! !

Avion subclass: #Comercial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Comercial methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^200.! !

!Comercial methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:58'!
printOn: aStream
	aStream nextPutAll: 'Avion Comercial ', self nombre , ' de ', self asientos size asString ,' asientos'.! !

!Comercial methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^800.! !

Avion subclass: #Jet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Jet methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^60.! !

!Jet methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:58'!
printOn: aStream
	aStream nextPutAll: 'Jet', self nombre , ' de ', self asientos size asString ,' asientos'.! !

!Jet methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^1200.! !

Object subclass: #Pasaje
	instanceVariableNames: 'vuelo persona fReserva nroAsiento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Pasaje subclass: #Business
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Business methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.75! !

Pasaje subclass: #Economica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Economica methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.5! !

!Pasaje class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/9/2012 23:49'!
newPersona: unaPersona vuelo: unVuelo nroAsiento: nroAsiento 
	|pasaje|
	pasaje := super new.
	pasaje vuelo: unVuelo.
	pasaje persona: unaPersona.
	pasaje fReserva: Date today.
	pasaje nroAsiento: nroAsiento.
	^pasaje.! !

!Pasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otroPasaje
	^self fReserva < otroPasaje fReserva! !

!Pasaje methodsFor: 'private' stamp: 'LeandroGomez 6/11/2012 12:08'!
coeficientePorFecha: unaFecha
	|dias coef coefAux|
	dias := (unaFecha - Date today) days.
	coef := 1.
	coefAux :=1.
	[ dias > (30*coefAux) ] whileTrue: [coef := coef + 0.25. coef := coef +1. dias := dias - (30*coefAux)].
	^coef.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 12:11'!
costo
	"Devuelve el costo del pasaje a la fecha actual"
	^(self costoALaFecha: Date today).! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 12:11'!
costoALaFecha: unaFecha
	"Devuelve el costo del pasaje , dependiendo del la fecha, mientras mas lejos de la fecha de despegue,
		menos saldr."
	" unaFecha debe ser del tipo <dia> <mesEnStrin> <ao>"
	^((self costoPorClase)*(self vuelo distanciaPromedio) / (self coeficientePorFecha: unaFecha)) rounded! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:28'!
costoPorClase
	self subclassResponsibility.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 11:56'!
distancia
	^self vuelo distanciaPromedio.
	! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 11:56'!
duracion 
	^self vuelo duracion.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva
	^ fReserva! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva: anObject
	fReserva := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento
	^ nroAsiento! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento: anObject
	nroAsiento := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona
	^ persona! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona: anObject
	persona := anObject! !

!Pasaje methodsFor: 'printing' stamp: 'LeandroGomez 6/12/2012 00:04'!
printOn: aStream
	"Terminar el printOn: "
	aStream nextPutAll:  'Pasaje de ',self persona printString .' con origen en ', 
						self vuelo origen, ' y destino en ', self vuelo destinoFinal.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo
	^ vuelo! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo: anObject
	vuelo := anObject! !

Pasaje subclass: #Primera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Primera methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^1.! !

Object subclass: #Persona
	instanceVariableNames: 'nombre apellido fnacimiento nacionalidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
newNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	|persona|
	persona := super new.
	persona nombre: unNombre;
			apellido: unApellido;
			fnacimiento: unaFecha asDate;
			nacionalidad: unaNacionalidad.
	^persona.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otraPersona
	^self fnacimiento < otraPersona fnacimiento.! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido
	^ apellido! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido: anObject
	apellido := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento
	^ fnacimiento! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento: anObject
	fnacimiento := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad
	^ nacionalidad! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad: anObject
	nacionalidad := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 13:10'!
printOn: aStream 
	aStream nextPutAll: 'Pasajero ', self nombre, ' ', self apellido , 'de origen ', self nacionalidad.! !

Object subclass: #SistemaDeReservas
	instanceVariableNames: 'folder pasajes vuelos personas aviones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance'!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance'!

!SistemaDeReservas class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/11/2012 18:06'!
new
	self error: 'Solo hay una unica instancia de esta clase'! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/12/2012 00:19'!
newDefault
	^ self newDefaultOnFolder:  'C:\'.! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 19:27'!
newDefaultOnFolder: aPath
	| sistema |
	sistema := super new.
	sistema folder: aPath.
	^sistema! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 18:04'!
uniqueInstance 
	uniqueInstance ifNil: [ uniqueInstance := SistemaDeReservas newDefault ].
	^uniqueInstance.! !

!SistemaDeReservas methodsFor: 'pasaje creation' stamp: 'LeandroGomez 6/11/2012 23:54'!
agregarPasaje: unPasaje
	self pasajes add: unPasaje.
	self escribirEnDisco: unPasaje.! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 6/11/2012 22:40'!
asignar: unaPersona asiento: nroAsiento vuelo: unVuelo
	unVuelo asignar: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones
	^ aviones! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones: anObject
	aviones := anObject! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:19'!
cancelar: unObjeto
	unObjeto cancelar! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:48'!
cancelar: nroAsiento vuelo: unVuelo
	unVuelo cancelar: nroAsiento! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:09'!
cantidadAsientos: unAvion
	^unAvion cantidadDeAsientos ! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:28'!
cantidadDeAsientos: unObjeto
	^unObjeto cantidadDeAsientos.! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:41'!
confirmar: nroAsiento vuelo: unVuelo
	unVuelo confirmar: nroAsiento! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 23:25'!
costo: unVuelo aLaFecha: unaFecha tipo: unTipo
	 | persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' nacionalidad: 'Argentino'.
	^(unTipo newPersona: persona vuelo: unVuelo nroAsiento: 1) costoALaFecha: unaFecha! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 23:19'!
costo: unVuelo tipo: unTipo
	 | persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' nacionalidad: 'Argentino'.
	^(unTipo newPersona: persona vuelo: unVuelo nroAsiento: 1) costo! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 23:28'!
costoPorClase: unTipo
	^unTipo costoPorClase! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:30'!
destinoFinal: unVuelo
	^unVuelo destinoFinal! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:15'!
distanciaPromedio: unObjeto
	^unObjeto distanciaPromedio.! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:30'!
duracion: unVuelo
	^unVuelo duracion! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:56'!
esPasajero: unaPersona asiento: nroAsiento vuelo: unVuelo
	^unVuelo esPasajero: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'escritura' stamp: 'LeandroGomez 6/12/2012 00:24'!
escribirEnDisco: unPasaje
	|stream aPath |
	aPath := self folder , 'Pasajes.txt'.
	stream := FileStream fileNamed: aPath.
	stream  nextPut: $<; 
		 	nextPutAll: unPasaje persona printString;
			nextPut: $>;
			nextPut: $<;
			nextPutAll: unPasaje vuelo fechaSalida asString;
			nextPut: $>;
			nextPut: $<;
			nextPutAll: unPasaje nroAsiento asString ;
			nextPut: $>.	
	stream close.
	! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:32'!
esperaDespegue: unVuelo
	^unVuelo esperaDespegue ! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:33'!
estaCancelado: unVuelo
	^unVuelo estaCancelado! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:34'!
estaConfirmado: unVuelo
	^unVuelo estaConfirmado ! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:34'!
estaConfirmado: nroAsiento vuelo:unVuelo
	^unVuelo estaConfirmado: nroAsiento ! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:59'!
estaLibre: nroAsiento vuelo: unVuelo
	^unVuelo estaLibre: nroAsiento! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:23'!
estaReservado: nroAsiento vuelo: unVuelo
	^unVuelo estaReservado: nroAsiento.! !

!SistemaDeReservas methodsFor: 'pasaje creation' stamp: 'LeandroGomez 6/11/2012 23:54'!
expender: unTipo persona: unaPersona vuelo: unVuelo asiento: nroAsiento
	( self estaLibre: nroAsiento vuelo:  unVuelo)
			ifTrue: [ self asignar: unaPersona asiento: nroAsiento vuelo: unVuelo. 
						self agregarPasaje: (unTipo newPersona: unaPersona vuelo:  unVuelo nroAsiento: nroAsiento) ]
			ifFalse: [ self error: 'asiento Ocupado' ]! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder
	^ folder! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder: anObject
	folder := anObject! !

!SistemaDeReservas methodsFor: 'initialization' stamp: 'LeandroGomez 6/12/2012 00:15'!
initialize 
	self pasajes: SortedCollection new;
		vuelos: SortedCollection new;
		personas: SortedCollection new;
		aviones: OrderedCollection new.! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:59'!
liberar: nroAsiento vuelo: unVuelo
	^unVuelo liberar: nroAsiento! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:36'!
pasajeroDelAsiento: nroAsiento vuelo: unVuelo
	^unVuelo pasajeroDelAsiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes
	^ pasajes! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes: anObject
	pasajes := anObject! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas
	^ personas! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas: anObject
	personas := anObject! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:25'!
reprogramar: unaFecha avion: unAvion vuelo: unVuelo
	unVuelo reprogramar: unaFecha avion: unAvion! !

!SistemaDeReservas methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 22:24'!
reprogramar: unaFecha vuelo: unVuelo
	unVuelo reprogramar: unaFecha! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:09'!
velocidadPromedio: unAvion
	^unAvion velocidadPromedio! !

!SistemaDeReservas methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 22:39'!
viaja: unaPersona vuelo: unVuelo
	^unVuelo viaja: unaPersona
	! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos
	^ vuelos! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos: anObject
	vuelos := anObject! !

Object subclass: #Vuelo
	instanceVariableNames: 'origen destino avion fechaSalida estado asientos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Vuelo subclass: #Internacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 00:33'!
distanciaPromedio
	^2000.! !

Vuelo subclass: #Transbordo
	instanceVariableNames: 'siguienteVuelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:55'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha 
	self error: 'Para un vuelo transbordo se necesita otro vuelo internacional/transbordo'! !

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:46'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha siguienteVuelo: otroVuelo

	|transbordo|
	transbordo := super newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha.
	transbordo siguienteVuelo: otroVuelo.
	^transbordo.! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 01:03'!
destinoFinal
	^self siguienteVuelo destinoFinal.! !

!Transbordo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 00:34'!
distanciaPromedio
	^2000 + (self siguienteVuelo distanciaPromedio).! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:55'!
duracion
	^ super duracion + self siguienteVuelo duracion.! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo
	^ siguienteVuelo! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo: anObject
	siguienteVuelo := anObject! !

!Vuelo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 19:51'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha
	|vuelo|
	vuelo := super new.
	vuelo origen: unOrigen;
		   destino: unDestino;
		   avion: unAvion;
		   fechaSalida: unaFecha;
		   asientos: OrderedCollection new.
		   1 to: unAvion cantidadDeAsientos do: [ :nro | vuelo asientos add: 
															(AsientoDeAvion newNumero: nro)].
	 ^vuelo.
	! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:12'!
< unVuelo
	^ self fechaSalida < unVuelo fechaSalida.! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/9/2012 23:07'!
= unVuelo
	^(self origen = unVuelo origen) & (self destino = unVuelo destino) & 
			( self fechaSalida = unVuelo fechaSalida ) ! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos
	^ asientos! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos: anObject
	asientos := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:03'!
asignar: unaPersona asiento: nro
	(nro <= self asientos size)
		ifTrue: [(self asientos detect: [ :asiento | asiento numero = nro] ) asignar: unaPersona.]
		ifFalse: [ self error: 'El asiento no existe']
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion
	^ avion! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion: anObject
	avion := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 08:26'!
cancelar
	self estado: 'Cancelado'.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:57'!
cantidadDeAsientos 
	^self avion cantidadDeAsientos.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
confirmar: nro
	| asiento|
	asiento := self asientos detect: [ :asient | asient numero = nro ].
	asiento estado: 'Confirmado'! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino
	^ destino! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino: anObject
	destino := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/10/2012 14:57'!
destinoFinal
	^ self destino.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 00:33'!
distanciaPromedio
	self subclassResponsibility.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:46'!
duracion
	^ self distanciaPromedio / self avion velocidadPromedio.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:04'!
esPasajero: unaPersona asiento: nroAsiento 
	|asiento|
	asiento := self asientos detect: [ :asient | asient numero = nroAsiento ].
	^asiento  esPasajero: unaPersona.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:29'!
esperaDespegue 
	^self estado = 'Esperando despegue'.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:27'!
estaCancelado
	^self estado = 'Cancelado'! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:54'!
estaConfirmado: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaConfirmado.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:55'!
estaLibre: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaLibre.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:55'!
estaReservado: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaReservado.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado
	^ estado! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado: anObject
	estado := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:49'!
fechaSalida
		^ fechaSalida
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:46'!
fechaSalida: anObject
	fechaSalida := anObject! !

!Vuelo methodsFor: 'initialization' stamp: 'LeandroGomez 6/9/2012 11:23'!
initialize 
	self estado: 'Esperando despegue'.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:55'!
liberar: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) liberar.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen
	^ origen! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen: anObject
	origen := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:18'!
pasajeroDelAsiento: nroAsiento

	^(self asientos detect: [ :asiento | asiento numero = nroAsiento]) persona! !

!Vuelo methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 13:08'!
printOn: aStream
	"Definir el stream"
	aStream nextPutAll: 'Vuelo desde: ', self origen, ' hasta ', self destino , 
						'. fecha de despegue: ', self fechaSalida asString.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
reprogramar: unaFecha 
	self reprogramar: unaFecha avion: self avion.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
reprogramar: unaFecha avion: unAvion
	(self asientos size < unAvion cantidadDeAsientos)
		ifTrue: [ self error: 'Debe ser un acion con la misma cantidad de asientos']
		ifFalse: [self fechaSalida: unaFecha.
				self estado: 'Reprogramado'.
				self avion: unAvion.]
	! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:05'!
viaja: unaPersona
	^self asientos anySatisfy: [ :asiento | asiento persona == unaPersona ].! !
